/*
   debug.c -- PIKT piktc & piktc_svc debug routines

   $Header: /var/cvs/PIKT/pikt/src/piktc/debug.c,v 1.21 2007/01/18 13:23:39 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2007 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#include "../lib/common.h"
#include "piktc.h"

void showhosts(unsigned long *);
void printbs(unsigned long *bs, int bslongs);

/* foreach host, output config lines for that host
 */
void
dumpcfgs (unsigned long *hbs)
{
	register int i, j;
	static unsigned long *hbscur;
	unsigned long hbsl;
	cfgln *clp;

	hbscur = (unsigned long *) NULL;
	for (i=0; i<hbslongs; i++) {
		hbsl = *(hbs+i);
		for (j=0; j<8*sizeof(unsigned long); j++) {
			if (hbsl & (1L<<j)) {
				hostcurr = *(hosts+((i*8*sizeof(unsigned long))+j));
				printf("\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ %s @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\n\n", hostcurr);
				FREE(hbscur);
				hbscur = bsdup(getbs(hostcurr, HST, FALSE), hbslongs);
				for (j=DEFCFG; j<=OBJCFG; j++) {
					printf("############################## %s ##############################\n", cfgfilenames[j]);
					foreach (clp, configs[j]) {
						if (bsmember(clp->bs, hbscur, hbslongs))
							printf("%-6d%5d    %s", clp->lineno, clp->doproc, clp->line);
					}
					printf("\n");
				}
			}
		}
	}
}

/* display all hostnames in the indicated hostset
 */
void
showhosts (unsigned long *hbs)
{
	register int i, j;
	unsigned long hbsl;

	for (i=0; i<hbslongs; i++) {
		hbsl = *(hbs+i);
		for (j=0; j<8*sizeof(unsigned long); j++) {
			if (hbsl & (1L<<j))
				printf("%s ", *(hosts+((i*8*sizeof(unsigned long))+j)));
		}
	}
	printf("\n");
}

/* output the longs making up a bitset
 */
void
printbs (unsigned long *bs, int bslongs)
{
	register int i;

	for (i=0; i<bslongs; i++)
		printf("%lu ", *(bs+i));
	printf("\n");
}
