%{

/*
   sys.y -- PIKT piktc parser for the systems.cfg file

   $Header: /var/cvs/PIKT/pikt/src/piktc/sys.y,v 1.25 2007/01/18 13:23:39 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2007 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#include "../lib/common.h"
#include "piktc.h"

ident *sidp;

%}

%union {
	char *sval;
}

%token <sval> _STANZA _HOST
%token _HOSTS _MEMBERS _ALIASES

%%

start:		systanzas
		;

systanzas:	systanza
		| systanzas systanza
		;

systanza:	system
		| alias
		| group
		;

system:		_STANZA {
			if (scanpass == 1) {
				opsysnum++;
			} else if (scanpass == 2) {
				sidp = regident($1, OPS, FALSE);
			}
		}
		_HOSTS
		systemhosts {
			if (scanpass == 1) {
				hstgrpnum++;
			} else if (scanpass == 3) {
				makenongroup($1);
			}
			if (scanpass != 2) {
				free($1);
			}
		}
		;

alias:		_STANZA {
			hostcurr = $1;
		}
		_ALIASES
		aliashosts {
			free($1);
		}
		;

group:		_STANZA {
			if (scanpass == 1) {
				hstgrpnum++;
			} else if (scanpass == 3) {
				sidp = regident($1, GRP, FALSE);
			}
		}
		_MEMBERS
		grouphosts {
			if (scanpass == 1) {
				hstgrpnum++;
			} else if (scanpass == 3) {
				makenongroup($1);
			}
			if (scanpass != 3) {
				free($1);
			}
		}
		;

systemhosts:	/* empty */
		| syshosts
		;

syshosts:	syshost
		| syshosts syshost
		;

aliashosts:	/* empty */
		| alshosts
		;

alshosts:	alshost
		| alshosts alshost
		;

grouphosts:	/* empty */
		| grphosts
		;

grphosts:	grphost
		| grphosts grphost
		;

syshost:	_HOST {
			if (scanpass == 1) {
				hostnum++;
			} else if (scanpass == 2) {
				sidp = regident($1, HST, FALSE);
				insert($1, HST);
			}
			if (scanpass != 2) {
				free($1);
			}
		}
		;

alshost:	_HOST {
			if (scanpass == 3) {
				sidp = regident($1, ALS, FALSE);
			}
			if (scanpass != 3) {
				free($1);
			}
		}
		;

grphost:	_HOST {
			if (scanpass == 3) {
				insert($1, HST);  /* or OPS, GRP, or ALS */
			}
			free($1);
		}
		;

%%
